/*
 *		functions of the buttons and dialogs
 */


#include "chemtool.h"
#include "TreeFSel.h"
#include <X11/cursorfont.h>

void Puttext(Widget w, char *str)
{
    XawTextBlock text;
    static XawTextPosition pos = 0;

    text.length = strlen(str);
    text.ptr = str;
    text.firstPos = 0;
    text.format = FMT8BIT;

    XawTextReplace(w, pos, pos, &text);

    pos += text.length;
    XawTextSetInsertionPoint(w, pos);
}

Widget MakeStringBox(parent, name, string, lenght)
Widget parent;
String name, string;
int lenght;
{
    Arg args[5];
    Cardinal numargs = 0;
    Widget StringW;

    XtSetArg(args[numargs], XtNeditType, XawtextEdit); numargs++;
    XtSetArg(args[numargs], XtNstring, string); numargs++;
    XtSetArg(args[numargs], XtNwidth, lenght); numargs++;

    StringW = XtVaCreateManagedWidget(name, asciiTextWidgetClass,
    parent, args, numargs);
    return(StringW);
}

String GetString(w)
Widget w;
{
    String str;
    Arg arglist[1];

    XtSetArg(arglist[0], XtNstring, &str);
    XtGetValues( w, arglist, ONE);
    return(str);
}

String SetString(w,str)
Widget w;
String str;
{
    Arg arglist[1];

    XtSetArg(arglist[0], XtNstring, str);
    XtSetValues( w, arglist, ONE);
    return(str);
}
String SetLabel(w,str)
Widget w;
String str;
{
    Arg arglist[1];

    XtSetArg(arglist[0], XtNlabel, str);
    XtSetValues( w, arglist, ONE);
    return(str);
}


void
FileCallback(w,client,call)
Widget w;
XtPointer client;
XtPointer call;
{
TreeFSelReturnStruct *ret;

        ret=(TreeFSelReturnStruct *)call;
                if (ret->button==1) {
                filetoload=ret->pathname;
                SetString(dialog, filetoload);
		XtPopdown(loaddialog);
		do_load_file();
		return;
        }        else {
		XtPopdown(loaddialog);
           return;
          }
    }
                                                                                                        


void load_file()
{
                                              
/*    String filename;*/
    Position x, y;
    Dimension w, h;

    XtVaGetValues(toplevel, XtNwidth, &w, XtNheight, &h, NULL);
    XtTranslateCoords(toplevel, (Position) w/2, (Position) h/10, &x, &y);
    XtVaSetValues(loaddialog, XtNx, x, XtNy, y, NULL);

    XtPopup(loaddialog,XtGrabNonexclusive);
}

void do_load_file()
{
 String   filename=filetoload;
    Position x, y;
    Dimension w, h;
    int xref,yref,xdiff,ydiff; 
    
    if (filename==NULL) return;
    
    if (addflag) {
    	add_mol(filename);
    	FreePix();
    	CreatePix();
    	Display_Mol();
    	SetLabel(diall,"Flip new fragment horizontally     ?");
        XtRemoveAllCallbacks(okdial, XtNcallback);
        XtAddCallback(okdial, XtNcallback, flip_horiz, NULL);
	XtVaGetValues(toplevel, XtNwidth, &w, XtNheight, &h, NULL);
	XtTranslateCoords(toplevel, (Position) w/2, (Position) h/2, &x, &y);
	XtVaSetValues(dialogbox, XtNx, x, XtNy, y, NULL);
	XtPopup(dialogbox, XtGrabNonexclusive);
/*    	SetLabel(diall,"Flip new fragment vertically       ?");
        XtRemoveAllCallbacks(okdial, XtNcallback);
        XtAddCallback(okdial, XtNcallback, flip_vert, NULL);
	XtVaGetValues(toplevel, XtNwidth, &w, XtNheight, &h, NULL);
	XtTranslateCoords(toplevel, (Position) w/2, (Position) h/2, &x, &y);
	XtVaSetValues(dialogbox, XtNx, x, XtNy, y, NULL);
	XtPopup(dialogbox, XtGrabNonexclusive);	
*/
    	addflag=0;
    	return;
    }	
    if(!load_mol(filename)) {
        FreePix();
	CreatePix();
	Display_Mol();
	}
    if(modify){
	XtPopdown(dialogbox);
	modify=False;
	}	
}

void Load()
{
    Position x, y;
    Dimension w, h;

    if(modify){
    	SetLabel(diall,"Figure not saved - discard changes ?");
        XtRemoveAllCallbacks(okdial, XtNcallback);
        XtAddCallback(okdial, XtNcallback, load_file, NULL);
	XtVaGetValues(toplevel, XtNwidth, &w, XtNheight, &h, NULL);
	XtTranslateCoords(toplevel, (Position) w/2, (Position) h/2, &x, &y);
	XtVaSetValues(dialogbox, XtNx, x, XtNy, y, NULL);
	XtPopup(dialogbox, XtGrabNonexclusive);
    }else load_file();
}

void Add()
{
struct data *hp_b;
struct dc *hp_a;

hp_b=da_root.next;
oldatoms=hp.n;
hp_a=dac_root.next;
oldlabels=hp.nc;

    XtUninstallTranslations(pix);
    XtOverrideTranslations(pix, camark);

XDefineCursor(XtDisplay(pix),XtWindow(pix), mycursor);

/*    addflag=1;
   load_file();
*/
}

void Save()
{
    Position x, y;
    Dimension w, h;
struct stat buffer;

    String filename = GetString(dialog);
    if(!stat(filename,&buffer)){
        SetLabel(diall,"File already exists - overwrite it ?");
        XtRemoveAllCallbacks(okdial, XtNcallback);
        XtAddCallback(okdial, XtNcallback, save_mol2, NULL);
	XtVaGetValues(toplevel, XtNwidth, &w, XtNheight, &h, NULL);
	XtTranslateCoords(toplevel, (Position) w/2, (Position) h/2, &x, &y);
	XtVaSetValues(dialogbox, XtNx, x, XtNy, y, NULL);
	XtPopup(dialogbox, XtGrabNonexclusive);
	}else
	if(!save_mol(filename)) modify=False;
}
void save_mol2()
{
String filename=GetString(dialog);
	XtPopdown(dialogbox);
if (!save_mol(filename)) modify=False;
}
void Export()
{
    Position x, y;
    Dimension w, h;

    XtVaGetValues(toplevel, XtNwidth, &w, XtNheight, &h, NULL);
    XtTranslateCoords(toplevel, (Position) w/2, (Position) h/2, &x, &y);
    XtVaSetValues(exportdialog, XtNx, x, XtNy, y, NULL);
    XtPopup(exportdialog, XtGrabNonexclusive);
}

void Close_Export()
{
    XtPopdown(exportdialog);
}

void XBM_Export()
{
    String filename = GetString(dialog);
    export_bitmap(filename);
}

void Xfig_Export()
{
    String filename = GetString(dialog);
    export_xfig(filename);
}

void LaTeX_Export()
{
    String filename = GetString(dialog);
    export_latex_pic(filename);
}


void PS_Export()
{
    String filename = GetString(dialog);
    export_ps_pic(filename);
}


void Really_Quit(w, client_data, call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
    XtPopdown(dialogbox);
    if((int) client_data) exit(0);
}

void Quit()
{
    Position x, y;
    Dimension w, h;

    if(modify){
        SetLabel(diall,"Figure not saved - discard changes ?");
        XtRemoveAllCallbacks(okdial, XtNcallback);
        XtAddCallback(okdial, XtNcallback, Really_Quit, (XtPointer)1);
	XtVaGetValues(toplevel, XtNwidth, &w, XtNheight, &h, NULL);
	XtTranslateCoords(toplevel, (Position) w/2, (Position) h/2, &x, &y);
	XtVaSetValues(dialogbox, XtNx, x, XtNy, y, NULL);
	XtPopup(dialogbox, XtGrabNonexclusive);
    }else exit(0);
}

void New()
{
    Position x, y;
    Dimension w, h;

    if(modify){
        SetLabel(diall,"Figure not saved - discard changes ?");
        XtRemoveAllCallbacks(okdial, XtNcallback);
        XtAddCallback(okdial, XtNcallback, Really_New, (XtPointer)1);
	XtVaGetValues(toplevel, XtNwidth, &w, XtNheight, &h, NULL);
	XtTranslateCoords(toplevel, (Position) w/2, (Position) h/2, &x, &y);
	XtVaSetValues(dialogbox, XtNx, x, XtNy, y, NULL);
	XtPopup(dialogbox, XtGrabNonexclusive);
    }else { clear_data();
    Display_Mol();
    }
}

void Really_New(w, client_data, call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
    XtPopdown(dialogbox);
    if((int) client_data) clear_data();
    modify=False;
    Display_Mol();
}

void Zoom(w, client_data, call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
    if((int) client_data) {
      if(zoom_factor) {
	zoom_factor=--zoom_factor;
	FreePix();
	CreatePix();
	Display_Mol();
	}
    }else{
      if(zoom_factor < 2) {
	zoom_factor=++zoom_factor;
	FreePix();
	CreatePix();
	Display_Mol();
	}
    }
}

void Change_Text(w, client_data, call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
    text_direct= (int) client_data;
    XtUninstallTranslations(pix);
    XtOverrideTranslations(pix ,catom);
}

void Change_Angle(w, client_data, call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
    draw_angle= (int) client_data;
    XtUninstallTranslations(pix);
    XtOverrideTranslations(pix ,ctrans1);
}

void Edit_Mol(w, client_data, call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
    XtUninstallTranslations(pix);
    XtOverrideTranslations(pix, crec);
    switch((int) client_data)
    {
     case 0:
      XtOverrideTranslations(pix, cmark);
      break;
     case 1:
      XtOverrideTranslations(pix, cdel);
      break;
     case 2:
      XtUninstallTranslations(pix);
      XtOverrideTranslations(pix, cmbond);
      break;
     case 3:
      XtUninstallTranslations(pix);
      XtOverrideTranslations(pix, cpmove);
      break;
    }
}

void UnMark(void)
{
    mark.flag=False;
    Display_Mol();
}

Widget toggle_icon(char *name,Widget tb, Widget pw, char *bitmap,
		    int width, int height)
{
    Pixel fg, bg;
    Display *display=XtDisplay(pw);

    Widget w=XtVaCreateManagedWidget(name, toggleWidgetClass,
                pw, XtNradioGroup, tb, NULL);
    XtVaGetValues(w, XtNforeground, &fg, XtNbackground, &bg, NULL);
    XtVaSetValues(w, XtNbitmap,
		XCreatePixmapFromBitmapData(display, 
		XDefaultRootWindow(display), bitmap, width, height, fg, bg,
		XDefaultDepthOfScreen(XtScreen(w))), NULL);
    return w;
}
